#include "List/List.h"
#include <iostream>

template <typename T>
class CircleList: public List<T>
{
    public:
        Node<T>* get_start() {
            return this->start;
        }

        CircleList() {}

        void add (T value) override{
            Node<T>* node = new Node<T>;
            node->value = value;
            if(this->start==nullptr) {
                this->start = node;
                this->end = node;
                return;
            }
            node->prev = this->end;
            node->next = this->start;
            this->end->next = node;
            this->start->prev = node;
            this->end = node;
            this->lenght++;
        }

        void add (T value, int index) override{
            static_cast<List<T>*>(this)->add(value, index);
            return;
        }

        void pop(Node<T>* n) {
            this->pop(n);
        }

        void pop() {
            this->end->prev->next = this->start;
            this->end = this->end->prev;
            this->lenght--;
        }

        void pop(int index) {
            this->pop(index);
        }

        friend std::ostream &operator <<(std::ostream &os, CircleList &c)
    {
        os << "( ";
        Node<T>* currentNode = c.start;
        for(int i = 0; i < c.lenght; i++)
        {
            os << currentNode->value << " = ";
            currentNode = currentNode->next;
        }
        os << currentNode->value << "... )";
        return os;
    }

};